import Wallet from './wallet';
/** Encapsulates artifacts from generating a random Wallet via a mnemonic and derivation path. */
export default class HdWalletGenerationResult {
    /** The mnemonic used to generate the wallet. */
    readonly mnemonic: string;
    /** The derivation path used to generate the wallet. */
    readonly derivationPath: string;
    /** The newly generated Wallet. */
    readonly wallet: Wallet;
    /**
     * Create a new HdWalletGenerationResult.
     *
     * @param mnemonic - The mnemonic used to generate the wallet.
     * @param derivationPath - The derivation path used to generate the wallet.
     * @param wallet - The newly generated wallet.
     */
    constructor(mnemonic: string, derivationPath: string, wallet: Wallet);
}
