"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/** Encapsulates artifacts from generating a random Wallet via a mnemonic and derivation path. */
class HdWalletGenerationResult {
    /**
     * Create a new HdWalletGenerationResult.
     *
     * @param mnemonic - The mnemonic used to generate the wallet.
     * @param derivationPath - The derivation path used to generate the wallet.
     * @param wallet - The newly generated wallet.
     */
    constructor(mnemonic, derivationPath, wallet) {
        this.mnemonic = mnemonic;
        this.derivationPath = derivationPath;
        this.wallet = wallet;
    }
}
exports.default = HdWalletGenerationResult;
//# sourceMappingURL=hd-wallet-generation-result.js.map