import Wallet from '../../../src/XRP/wallet';
/**
 * A fake wallet which always produces the given signature.
 */
declare class FakeWallet extends Wallet {
    private readonly signature;
    /**
     * Initialize a wallet which will always produce the same signature when asked to sign a string.
     *
     * @param signature - The signature this wallet will produce.
     * @param publicKey - The public key associated with this wallet / account.
     * @param privateKey - The private key associated with this wallet / account.
     */
    constructor(signature: string, publicKey?: string, privateKey?: string);
    /**
     * Return an identical fake signature for any input.
     *
     * @param _hex - The hex to sign. (Unused - used only to maintain call signature).
     *
     * @returns A fake signature.
     */
    sign(_hex: string): string;
}
export default FakeWallet;
